#![feature(array_windows)]
use std::fs;

/// AoC2021 Day 1, Rust 2021 nightly with array_windows
fn main() {
    let mut input = fs::read_to_string("input")
        .unwrap().lines()
        .map(|x| x.parse().unwrap())
        .collect::<Vec<i32>>();

    println!("{}", puzzle1(&input));
    println!("{}", puzzle2(&input));
}

fn puzzle1(input: &[i32]) -> i32{
    input.array_windows()
         .fold(0, |acc, [a, b]|
             { if a < b { acc + 1 }
             else       { acc     } })
}

fn puzzle2(input: &[i32]) -> i32{
    input.array_windows()
         .fold(0, |acc, [a, b, c, d]|
             { if a+b+c < b+c+d { acc + 1 }
               else             { acc     } })
}